"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SVGPickerPlugin = void 0;

var _tslib = require("tslib");

var _manaSyringe = require("mana-syringe");

var _g = require("@antv/g");

/**
 * pick shape(s) with Mouse/Touch event
 *
 * 1. find AABB with r-tree
 * 2. use elementFromPoint
 */
var SVGPickerPlugin =
/** @class */
function () {
  function SVGPickerPlugin() {}

  SVGPickerPlugin.prototype.apply = function (renderingService) {
    var _this = this;

    renderingService.hooks.pick.tapPromise(function (result) {
      return (0, _tslib.__awaiter)(_this, void 0, void 0, function () {
        var topmost, _a, clientX, clientY, targets, _b, _c, element, id, index, target;

        var e_1, _d;

        return (0, _tslib.__generator)(this, function (_e) {
          topmost = result.topmost, _a = result.position, clientX = _a.clientX, clientY = _a.clientY;

          try {
            targets = [];

            try {
              // @see https://developer.mozilla.org/zh-CN/docs/Web/API/Document/elementsFromPoint
              for (_b = (0, _tslib.__values)(document.elementsFromPoint(clientX, clientY)), _c = _b.next(); !_c.done; _c = _b.next()) {
                element = _c.value;
                id = element && element.getAttribute('id');

                if (id && id.startsWith('g_')) {
                  index = id.lastIndexOf('_');
                  target = this.displayObjectPool.getByEntity(Number(id.substring(index + 1))); // don't need to account for `visibility` since DOM API already does

                  if (target && target.isInteractive()) {
                    targets.push(target);

                    if (topmost) {
                      result.picked = targets;
                      return [2
                      /*return*/
                      , result];
                    }
                  }
                }
              }
            } catch (e_1_1) {
              e_1 = {
                error: e_1_1
              };
            } finally {
              try {
                if (_c && !_c.done && (_d = _b.return)) _d.call(_b);
              } finally {
                if (e_1) throw e_1.error;
              }
            }

            result.picked = targets;
          } catch (e) {
            result.picked = [];
          }

          return [2
          /*return*/
          , result];
        });
      });
    });
  };

  (0, _tslib.__decorate)([(0, _manaSyringe.inject)(_g.SceneGraphService), (0, _tslib.__metadata)("design:type", Object)], SVGPickerPlugin.prototype, "sceneGraphService", void 0);
  (0, _tslib.__decorate)([(0, _manaSyringe.inject)(_g.DisplayObjectPool), (0, _tslib.__metadata)("design:type", _g.DisplayObjectPool)], SVGPickerPlugin.prototype, "displayObjectPool", void 0);
  SVGPickerPlugin = (0, _tslib.__decorate)([(0, _manaSyringe.singleton)({
    contrib: _g.RenderingPluginContribution
  })], SVGPickerPlugin);
  return SVGPickerPlugin;
}();

exports.SVGPickerPlugin = SVGPickerPlugin;